//Datei: FLIPPIE.C
// Flippie-Licht
//
// Bedienung:
// Taster drcken startet das Gert
// Taster nochmal drcken schaltet einen Mode weiter
// Zum Schlu geht der PIC in den Sleepmode
// 
// Copyright 1999 by Holger Klabunde
// 30.04.2001
// Compiler CC5x

#include <12C508.h>
#include <inline.h>

enum { NIX, LAUF, HINHER, HEKTIK, MULTIPLEX, REIN, RAUS, REINRAUS, STILL };

#define MULTTIME 	10 	//ms zwischen den LED's fr Multiplexbetrieb
#define LAUFTIME	100 	//Zeit des Lauflichtes
#define HINHERTIME	50 	//Zeiten des Knight-Rider
#define HEKTIKTIME	30      //Zeit des Chaotenlichtes
#define REINTIME	200     //Zeit fr von auen nach innen und zurck

//Neue Namen fr die Ledpins. GPIO.3 ist ein Eingang und strt die Zhlweise
#define L1	GPIO.0
#define L2	GPIO.1
#define L3	GPIO.2
#define L4	GPIO.4
#define L5	GPIO.5
#define TAST	GPIO.3
#define ON	0     //Led's an Plus angeschlossen deshalb hier invertieren
#define OFF	1

//Das Configurationword !
#pragma config |=0xFEA

unsigned char mode;


void Delay1ms(unsigned char time);

/* Hauptprogramm */
void main()
{
 unsigned char time,k,l;
 
 OPTION=0b00011111; //Wake up on pin change, weak pullups, Timer0 int. Source
 		       //Sonst GP2 Eingang !!

//Nur GP0,1,3 haben Pullups. Damit kommen nur sie als Eingnge in Frage
//Ich nehme GP3 als Tastereingang, weil er kein Ausgang werden kann !

 TRIS=0b001000; 	//0=Ausgang, 1=Eingang

 GPIO=0b111111;	//Anfangszustand LED's aus. 1 weil die hngen gegen +Ub !!

 if(mode==STILL) mode=NIX;    	//Wakeup from SLEEP(); aufgetreten, dann ist Taste gedrckt!!
 else mode=LAUF;                //Batteriewechsel, dann Start mit Lauflicht
 
 while(1) // Anfang Programm Endlosschleife
  {


   if(TAST==0)
    {
     while(TAST==0)  //warten bis Taste losgelassen wird
      {
       for(k=0; k<100; k++) //Entprellen !! eigentlich identisch mit Delay1ms(100)
        {                   //Dort wird jetzt aber TAST!=0 abgefragt, was hier strt.
         for(l=0; l<100; l++)
          {
           //Ein CPU-Clock = 1us
           NOP; NOP; NOP; NOP; NOP;
           NOP; NOP; NOP; NOP; NOP; //10us * 100 = 1ms
          }
        }
      }
      
     mode++; //Nchster mode
    }

//Lauflicht das von beiden Seiten kommt, und bis zur Mitte geht
   if(mode==REIN)
    {
     L1=ON; L5=ON; Delay1ms(REINTIME); L1=OFF; L5=OFF;
     L2=ON; L4=ON; Delay1ms(REINTIME); L2=OFF; L4=OFF;
     L3=ON; Delay1ms(REINTIME); L3=OFF;     
    }

//Lauflicht das von der Mitte kommt, und zu beiden Seiten geht
   if(mode==RAUS)
    {
     L3=ON; Delay1ms(REINTIME); L3=OFF;     
     L2=ON; L4=ON; Delay1ms(REINTIME); L2=OFF; L4=OFF;
     L1=ON; L5=ON; Delay1ms(REINTIME); L1=OFF; L5=OFF;
    }

//Lauflicht das von beiden Seiten kommt, und bis zur Mitte geht
   if(mode==REINRAUS)
    {
     L1=ON; L5=ON; Delay1ms(REINTIME); L1=OFF; L5=OFF;
     L2=ON; L4=ON; Delay1ms(REINTIME); L2=OFF; L4=OFF;
     L3=ON; Delay1ms(REINTIME); L3=OFF;     
     L2=ON; L4=ON; Delay1ms(REINTIME); L2=OFF; L4=OFF;
    }

//Die mittlere LED zeigt nach hinten und bekommt am meisten Zugriff
//Die LED's links und rechts davon die Hlfte der mittleren
//Die LED's ganz auen die Hlfte von den inneren
   if(mode==HEKTIK)
    {
     //Wir beginnen in der Mitte
     L3=ON; Delay1ms(HEKTIKTIME); L3=OFF; Delay1ms(HEKTIKTIME);
     L3=ON; Delay1ms(HEKTIKTIME); L3=OFF; Delay1ms(HEKTIKTIME);
     //Nach links
     L2=ON; Delay1ms(HEKTIKTIME); L2=OFF; Delay1ms(HEKTIKTIME);
     //Wieder in die Mitte, und zweimal blinken
     L3=ON; Delay1ms(HEKTIKTIME); L3=OFF; Delay1ms(HEKTIKTIME);
     L3=ON; Delay1ms(HEKTIKTIME); L3=OFF; Delay1ms(HEKTIKTIME);
     //Nach rechts
     L4=ON; Delay1ms(HEKTIKTIME); L4=OFF; Delay1ms(HEKTIKTIME);
     //Wieder in die Mitte, und zweimal blinken
     L3=ON; Delay1ms(HEKTIKTIME); L3=OFF; Delay1ms(HEKTIKTIME);
     L3=ON; Delay1ms(HEKTIKTIME); L3=OFF; Delay1ms(HEKTIKTIME);

     //Nach links auen
     L1=ON; Delay1ms(HEKTIKTIME+HEKTIKTIME); L1=OFF; Delay1ms(HEKTIKTIME);
     //Wieder in die Mitte, und zweimal blinken
     L3=ON; Delay1ms(HEKTIKTIME); L3=OFF; Delay1ms(HEKTIKTIME);
     L3=ON; Delay1ms(HEKTIKTIME); L3=OFF; Delay1ms(HEKTIKTIME);
     //Nach rechts weil ich vorher schon links war
     L4=ON; Delay1ms(HEKTIKTIME); L4=OFF; Delay1ms(HEKTIKTIME);
     //Wieder in die Mitte, und zweimal blinken
     L3=ON; Delay1ms(HEKTIKTIME); L3=OFF; Delay1ms(HEKTIKTIME);
     L3=ON; Delay1ms(HEKTIKTIME); L3=OFF; Delay1ms(HEKTIKTIME);
     //Nach links
     L2=ON; Delay1ms(HEKTIKTIME); L2=OFF; Delay1ms(HEKTIKTIME);

     //Wieder in die Mitte, und zweimal blinken
     L3=ON; Delay1ms(HEKTIKTIME); L3=OFF; Delay1ms(HEKTIKTIME);
     L3=ON; Delay1ms(HEKTIKTIME); L3=OFF; Delay1ms(HEKTIKTIME);
     //Nach rechts auen
     L5=ON; Delay1ms(HEKTIKTIME+HEKTIKTIME); L5=OFF; Delay1ms(HEKTIKTIME);
     //Wieder in die Mitte, und zweimal blinken
     L3=ON; Delay1ms(HEKTIKTIME); L3=OFF; Delay1ms(HEKTIKTIME);
     L3=ON; Delay1ms(HEKTIKTIME); L3=OFF; Delay1ms(HEKTIKTIME);
     //Nach links
     L2=ON; Delay1ms(HEKTIKTIME); L2=OFF; Delay1ms(HEKTIKTIME);
     //Wieder in die Mitte, und zweimal blinken
     L3=ON; Delay1ms(HEKTIKTIME); L3=OFF; Delay1ms(HEKTIKTIME);
     L3=ON; Delay1ms(HEKTIKTIME); L3=OFF; Delay1ms(HEKTIKTIME);
     //Nach rechts
     L4=ON; Delay1ms(HEKTIKTIME); L4=OFF; Delay1ms(HEKTIKTIME);
     //Und oben wieder anfangen
    }
    
   if(mode==LAUF) //Lauflicht
    {
     L1=ON; Delay1ms(LAUFTIME); L1=OFF; 
     L2=ON; Delay1ms(LAUFTIME); L2=OFF; 
     L3=ON; Delay1ms(LAUFTIME); L3=OFF; 
     L4=ON; Delay1ms(LAUFTIME); L4=OFF; 
     L5=ON; Delay1ms(LAUFTIME); L5=OFF; 
    }

//Der Trick hier ist an der richtigen Stelle anzufangen
//damit es auf beiden Seiten gleich flssig aussieht.
//Eigentlich mte zuerst LED_ON(1); auftauchen.
//Versuch doch mal mit LED_ON(1); anzufangen :)
   if(mode==HINHER) //Das Knight-Rider laufen
    {
     //Led's berschneiden lassen
     L2=ON;  Delay1ms(HINHERTIME);
     L1=OFF; Delay1ms(HINHERTIME);
     L3=ON;  Delay1ms(HINHERTIME);
     L2=OFF; Delay1ms(HINHERTIME);
     L4=ON;  Delay1ms(HINHERTIME);
     L3=OFF; Delay1ms(HINHERTIME);
     L5=ON;  Delay1ms(HINHERTIME);
     L4=OFF; Delay1ms(HINHERTIME); Delay1ms(HINHERTIME); //Sieht flssiger aus

     //Und zurck
     L4=ON;  Delay1ms(HINHERTIME);
     L5=OFF; Delay1ms(HINHERTIME);
     L3=ON;  Delay1ms(HINHERTIME);
     L4=OFF; Delay1ms(HINHERTIME);
     L2=ON;  Delay1ms(HINHERTIME);
     L3=OFF; Delay1ms(HINHERTIME);
     L1=ON;  Delay1ms(HINHERTIME);
     L2=OFF; Delay1ms(HINHERTIME); Delay1ms(HINHERTIME);
    }

   if(mode==MULTIPLEX) //Alle an im Multiplex
    {
//Led's flimmern absichtlich
     L1=ON; Delay1ms(MULTTIME); L1=OFF; 
     L2=ON; Delay1ms(MULTTIME); L2=OFF; 
     L3=ON; Delay1ms(MULTTIME); L3=OFF; 
     L4=ON; Delay1ms(MULTTIME); L4=OFF; 
     L5=ON; Delay1ms(MULTTIME); L5=OFF; 
    }
   
   if(mode==STILL) //Abschalten
    {
     GPIO=0b111111; //Alle Leds aus
     SLEEP; //Warten auf nchsten Knopfdruck
     //Wenn die Taste gedrckt wird, erfolgt ein Reset!!
    }
     
  } // Ende Programm Endlosschleife
}

//Nicht sonderlich genau !!
//time<=255 !!
void Delay1ms(unsigned char time)
{
 unsigned char k,l;

if(TAST!=0) //Nur verzgern wenn keine Taste gedrckt ist !
 {
  for(k=0; k<time; k++)
   {
    for(l=0; l<100; l++)
     {
      //Ein CPU-Clock = 1us
      NOP; NOP; NOP; NOP; NOP; //5us
      NOP; NOP; NOP; NOP; NOP; //5us
     }
   }
 }
}
